

/*

________________________________________________________________

        ImageOverlayResize.c
        %W% %E%, Copyright 1990, Blab, UiO
        Image processing lab, Department of Informatics
        University of Oslo
        E-mail: blab@uio.no
________________________________________________________________
  
  Permission to use, copy, modify and distribute this software and its
  documentation for any purpose and without fee is hereby granted, 
  provided that this copyright notice appear in all copies and that 
  both that copyright notice and this permission notice appear in supporting
  documentation and that the name of B-lab, Department of Informatics or
  University of Oslo not be used in advertising or publicity pertaining 
  to distribution of the software without specific, written prior permission.

  B-LAB DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL
  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL B-LAB
  BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
  WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION
  OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN 
  CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 

*/

typedef unsigned char ImagePixel; 
static unsigned char trans[256];

#define ImageXxxxResize ImageOverlayResize
#define ImageXxxxPrintf ImageOverlayPrintf
#define PrintfFormat "%d"

#define R_NO(a) *a++
#define R_YES(a) a[*xptr]
#define EQ_PRO(left, OP, right) left OP trans[right]
#define EQ_24(a) { j = a; if (j) *ptr++ = trans[j]; else ptr++; }
#define EQ_8(a)  { j = a; if (j) *ptr++ = trans[j]; else ptr++; }
#define EQ_4A(a) { j = a; if (j){k = (*ptr & 0xf) << 4; *ptr &= 0xf0;\
				   *ptr += trans[k];} ptr++;}
#define EQ_4B(a) { j = a; if (j){k = *ptr; *ptr &= 0x0f;\
				   *ptr += (trans[k] << 4);}}
#define EQ_2A(a) (a)
#define EQ_2B    ^= 


#define INIT24\
  for(i=0; i<256; i++) trans[i] = i >=128 ? i-128 : i+128;
#define INIT8\
  for(i=0; i<256; i++) trans[i] = (i * 147) & 0xff;
#define INIT7\
  for(i=0; i<256; i++) trans[i] = 192 + (i % 32);
#define INIT4\
  for(i=0; i<256; i++) trans[i] = i >=128 ? ((i-128) >> 4) : ((i+128) >> 4);
#define INIT2

#define ADDRESS ImageOverlayScreenXYtoAdr


#include "ImageProtoPix.c

